<template>
  <div class="group-list flex flex-col h-full">
    <div class="flex justify-between">
      <div class="text-xl font-semibold">ประเภทกลุ่ม</div>

      <div
        v-if="group_data.length > 0"
        class="text-5xl leading-4 cursor-pointer"
        @click="showCreateModal"
      >
        +
      </div>
    </div>

    <div
      v-if="group_data.length > 0"
      style="height: calc(100% - 44px)"
      class="mt-4 -mx-4 overflow-y-auto"
    >
      <div
        v-for="(group, index) in group_data"
        :key="index"
        :class="{
          'flex items-center justify-between p-4': true,
          'bg-primary': group.id === selected_group.id,
        }"
      >
        <div
          class="cursor-pointer flex items-center flex-1 mr-3"
          @click="selectGroup(group)"
        >
          <img
            :src="require('~/assets/images/street-light (1) 1.svg')"
            alt="street-light (1) 1.svg"
            class="mr-3"
          />

          {{ group.name }}
        </div>

        <div class="flex items-center">
          <el-switch
            v-model="group.status"
            @change="switchGroupLight(group)"
          ></el-switch>

          <img
            :src="require('~/assets/images/edit 1.svg')"
            alt="edit 1.svg"
            class="ml-3 cursor-pointer"
            @click="showEditModal(group)"
          />
        </div>
      </div>
    </div>

    <div v-else class="flex-1 flex items-center justify-center">
      <div
        class="cursor-pointer text-grey text-center"
        @click="showCreateModal"
      >
        <div class="text-5xl leading-4">+</div>

        <div class="mt-3">สร้างกลุ่ม</div>
      </div>
    </div>

    <div v-if="show_modal" class="fixed inset-0 z-50">
      <div
        class="absolute bg-black bg-opacity-80 inset-0"
        @click="closeModal"
      ></div>

      <div
        class="rounded-md bg-darkblue p-8 absolute top-2/4 left-2/4 transform -translate-x-2/4 -translate-y-2/4 w-5/6 overflow-auto max-h-[85%]"
      >
        <LightingGroupModal
          :mode="modal_mode"
          :edit_group="edit_group"
          :closeModal="closeModal"
          :addGroup="addGroup"
          :editGroup="editGroup"
          :light_data="light_data"
        />
      </div>
    </div>
  </div>
</template>

<script>
import Vue from "vue";
import _ from "lodash";
import { Switch } from "element-ui";
Vue.use(Switch);

export default {
  props: {
    group_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    light_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selected_group: {
      type: Object,
      default: () => {
        return {};
      },
    },
    selectGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    addGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    editGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    switchGroupLight: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      show_modal: false,
      modal_mode: "add",
      edit_group: {},
    };
  },
  methods: {
    closeModal() {
      this.show_modal = false;
    },
    showCreateModal() {
      this.modal_mode = "add";
      this.show_modal = true;
    },
    showEditModal(group) {
      this.modal_mode = "edit";
      this.show_modal = true;
      this.edit_group = group;
    },
  },
};
</script>

<style lang="scss" scoped></style>
